package scripts;

import scripts.*;
import scripts.roles.*;

class Actor {
	def name;					// Actor's name
	def skypeid;				// Actor's Skype ID
	def state = State.live;		// State of live/dead
	def nextstate = State.live;	// Next state of live/dead
	def countdown = 0;			// Changing state timer
	def role;					// Actor's role
	def target;					// Target for action
	def noticelog = [];			// Notified log
	def defended = false;		// Defended by Hunter
	def divined = false;		// Divined by fortuneteller
	def suspended = null;		// Suspended a command
	Actor(name) {
		this.name = name;
		setRole(Civilian);
	}
	def setRole(role) {
		this.role = role.newInstance(this);
	}
	def methodMissing(String name, args) {
		return role.invokeMethod(name, args);
	}
}
